package jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.core.AID;
import jade.core.Agent;
import jade.domain.JADEAgentManagement.KillAgent;
import jade.domain.JADEAgentManagement.JADEManagementOntology;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;
import jadex.adapter.fipa.AgentIdentifier;
import jadex.adapter.jade.SJade;

/**
 *  Plan for destroying a given agent on JADE.
 */
public class JadeAMSDestroyAgentPlan extends Plan
{
	/**
	 *  Execute a plan.
	 */
	public void body()
	{
		AgentIdentifier	aid	= (AgentIdentifier)getParameter("agentidentifier").getValue();
		AgentIdentifier	amsfipa	= (AgentIdentifier)getParameter("ams").getValue();
		AID	amsjade;
		if(amsfipa==null)
		{
			// Use local ams when not specified in goal.
			amsjade	= ((Agent)getScope().getPlatformAgent()).getAMS();
			amsfipa	= SJade.convertAIDtoFipa(amsjade);
		}
		else
		{
			amsjade	= SJade.convertAIDtoJade(amsfipa);
		}

		KillAgent	kill	= new KillAgent();
		kill.setAgent(SJade.convertAIDtoJade(aid));

		IGoal	req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(amsfipa);
		req.getParameter("action").setValue(new Action(amsjade, kill));
		req.getParameter("ontology").setValue(JADEManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);
	}
}
