package jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.content.onto.basic.Result;
import jade.core.AID;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.FIPAManagementOntology;
import jade.domain.FIPAAgentManagement.Search;
import jadex.adapter.fipa.*;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;
import jadex.runtime.Plan;

/**
 *  Plan for searching for JADE agents.
 */
public class JadeAMSSearchAgentsPlan extends Plan
{
	/**
	 *  Execute a plan.
	 */
	public void body()
	{
		AMSAgentDescription	description	= (AMSAgentDescription)getParameter("description").getValue();
		SearchConstraints	constraints	= (SearchConstraints)getParameter("constraints").getValue();
		AgentIdentifier	amsfipa	= (AgentIdentifier)getParameter("ams").getValue();
		AID	amsjade;
		if(amsfipa==null)
		{
			// Use local ams when not specified in goal.
			amsjade	= ((Agent)getScope().getPlatformAgent()).getAMS();
			amsfipa	= SJade.convertAIDtoFipa(amsjade);
		}
		else
		{
			amsjade	= SJade.convertAIDtoJade(amsfipa);
		}

		Search	search	= new Search();
		search.setDescription(SJade.convertAMSAgentDescriptiontoJade(description));
		if(constraints!=null)
			search.setConstraints(SJade.convertSearchConstraintstoJade(constraints));
		else
			search.setConstraints(new jade.domain.FIPAAgentManagement.SearchConstraints());

		IGoal	req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(amsfipa);
		req.getParameter("action").setValue(new Action(amsjade, search));
		req.getParameter("ontology").setValue(FIPAManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);

		Result res = (Result)req.getParameter("result").getValue();

		Object[]	items	= res.getItems().toArray();
		for(int i=0; i<items.length; i++)
		{
			getParameterSet("result").addValue(
				SJade.convertAMSAgentDescriptiontoFipa((jade.domain.FIPAAgentManagement.AMSAgentDescription)items[i]));
		}
	}
}
