package jadex.adapter.jade.planlib;

import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.introspection.BornAgent;
import jade.domain.introspection.DeadAgent;
import jade.domain.introspection.Event;
import jade.domain.introspection.EventRecord;
import jade.domain.introspection.Occurred;
import jade.domain.introspection.ResumedAgent;
import jade.domain.introspection.SuspendedAgent;
import jadex.adapter.jade.SJade;
import jadex.runtime.IBeliefSet;
import jadex.runtime.IMessageEvent;
import jadex.runtime.Plan;
import jadex.util.SUtil;

/**
 *  Plan for processing Jade introdpection events.
 */
public class JadeAMSUpdatePlan extends Plan
{
	/**
	 *  The plan body.
	 */
	public void body()
	{
		//System.out.println("Initial event is: "+getInitialEvent());
		
		Occurred o = (Occurred)((IMessageEvent)getInitialEvent()).getContent();
		EventRecord er = (EventRecord)o.getWhat();
		Event event = er.getWhat();
		if(event instanceof BornAgent)
		{
			BornAgent ba = (BornAgent)event;
			AMSAgentDescription tmp = new AMSAgentDescription();
			tmp.setName(ba.getAgent());
			tmp.setState(ba.getState());
			tmp.setOwnership(ba.getOwnership());
			jadex.adapter.fipa.AMSAgentDescription desc = SJade.convertAMSAgentDescriptiontoFipa(tmp);
			
			IBeliefSet	agents	= getBeliefbase().getBeliefSet("agents");
			agents.addFact(desc);
			
			//System.out.println("Agent born: "+desc);
			//System.out.println(SUtil.arrayToString(desc.getName().getAddresses()));
		}
		else if(event instanceof DeadAgent)
		{
			DeadAgent da = (DeadAgent)event;
			AMSAgentDescription tmp = new AMSAgentDescription();
			tmp.setName(da.getAgent());
			jadex.adapter.fipa.AMSAgentDescription desc = SJade.convertAMSAgentDescriptiontoFipa(tmp);
			
			IBeliefSet	agents	= getBeliefbase().getBeliefSet("agents");
			agents.removeFact(desc);
		
			//System.out.println("Agent died: "+desc);
		}
		else if(event instanceof SuspendedAgent)
		{
			SuspendedAgent sa = (SuspendedAgent)event;
			AMSAgentDescription tmp = new AMSAgentDescription();
			tmp.setName(sa.getAgent());
			tmp.setState(AMSAgentDescription.SUSPENDED);
			// todo: support ownership?
			jadex.adapter.fipa.AMSAgentDescription desc = SJade.convertAMSAgentDescriptiontoFipa(tmp);
			
			IBeliefSet	agents	= getBeliefbase().getBeliefSet("agents");
			agents.updateFact(desc);
			//System.out.println("Agent suspended: "+desc);
		}
		else if(event instanceof ResumedAgent)
		{
			ResumedAgent sa = (ResumedAgent)event;
			AMSAgentDescription tmp = new AMSAgentDescription();
			tmp.setName(sa.getAgent());
			tmp.setState(AMSAgentDescription.ACTIVE);
			// todo: support ownership?
			jadex.adapter.fipa.AMSAgentDescription desc = SJade.convertAMSAgentDescriptiontoFipa(tmp);
			
			IBeliefSet	agents	= getBeliefbase().getBeliefSet("agents");
			agents.updateFact(desc);
			//System.out.println("Agent resumed: "+desc);
		}
		else
		{
			//System.out.println("Unprocessed event: "+event);
		}
	}
}
