package	jadex.adapter.jade.planlib;

import jade.content.onto.basic.Action;
import jade.content.onto.basic.Done;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.*;
import jadex.adapter.jade.SJade;
import jadex.runtime.IGoal;

import java.util.Date;

/**
 *  Create a new modify plan.
 */
public class JadeDFModifyPlan	extends	JadeDFPlan
{
	//-------- attributes --------

	/** The debug flag. */
	protected boolean	debug	= true;

	//-------- constructors --------

	/**
	 *  Create a new plan.
	 */
	public JadeDFModifyPlan()
	{
		// Set the lease time. Will maybe get one from server if not set.
		Long lt = (Long)getParameter("leasetime").getValue();
		if(lt!=null)
		{
			//new DFAgentDescription().setRelativeLeaseTime(lt.longValue());
			getAgentDescription().setLeaseTime(
				new Date(System.currentTimeMillis()+lt.longValue()));
		}
		// When AID is ommited, enter self. Hack???
		if(getAgentDescription().getName()==null)
			getAgentDescription().setName(((Agent)getCapability().getPlatformAgent()).getAID());
	}

	//-------- methods --------

	/**
	 *  The plan body.
	 */
	public void	body()
	{
		// Try to modify registration.
		Modify	modify	= new Modify();
		modify.setDescription(getAgentDescription());
		Action action = new Action();
		action.setActor(SJade.convertAIDtoJade(getDF()));
		action.setAction(modify);

		IGoal	req	= createGoal("rp_initiate");
		req.getParameter("receiver").setValue(getDF());
		req.getParameter("action").setValue(action);
		req.getParameter("ontology").setValue(FIPAManagementOntology.NAME);
		req.getParameter("language").setValue(jade.domain.FIPANames.ContentLanguage.FIPA_SL0);
		dispatchSubgoalAndWait(req);

		Modify mod	= (Modify)((Action)((Done)req
			.getParameter("result").getValue()).getAction()).getAction();

		Object desc= mod.getDescription();
		desc = SJade.convertAgentDescriptiontoFipa((DFAgentDescription)desc);
		getParameter("result").setValue(desc);
	}
}
