package jadex.adapter.jade.tools.common;

import javax.swing.*;

import jadex.util.*;

/**
 *
 */
public class GuiProperties
{
	//-------- constants --------

	/**
	 * The image  for (m/r) elements.
	 */
	private static UIDefaults icons = new UIDefaults(new Object[]
	{
		"RMAAction.LoggerActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/logger.png"),
		"RMAAction.JadexIntrospectorActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/jdxintro.png"),
		"RMAAction.TracerActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/tracer.png"),

		// Runtime elements.
		"RCapability", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_capability_small.png"),
		"RBDIAgent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_agent.png"),
		"RBeliefbase", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/beliefbase2.png"),
		"RGoalbase", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/goalbase2.png"),
		"RPlanbase", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/planbase2.png"),
		"RBelief", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulb2.png"),
		"RBeliefSet", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulb2.png"),
		"RBeliefSetContainer", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulbs2.png"),
		"RBeliefReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulb2ref.png"),
		"RBeliefSetReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulb2ref.png"),
		"RBeliefSetReferenceContainer", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bulbs2ref.png"),
//		"RAbstractGoal",	SGUI.makeIcon(""),
		"RGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2.png"), // Used for goalbase panel (hack???)
		"RAchieveGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2.png"),
		"RMaintainGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2.png"),
		"RPerformGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2.png"),
		"RQueryGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2.png"),
		"RAchieveGoalReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2ref.png"),
		"RMaintainGoalReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2ref.png"),
		"RPerformGoalReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2ref.png"),
		"RQueryGoalReference", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/cloud2ref.png"),
		"RProcessGoal", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/gearwheel2.png"),
		"RPlan", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/plan2.png"),
		"RMessageEvent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_message_small.png"),
		"RInternalEvent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/internal.png"),
		"RGoalEvent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/goalevent.png"),

		// Model elements.
		"MCapability", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_capability_small.png"),
		"MBDIAgent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_agent.png"),
		"Capability", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_capability_small.png"),
		"Agent", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_agent.png"),

		// APL candidates.
		"PlanInstanceInfo", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/plan2.png"),
		"WaitqueueInfo", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/wplan.png"),
		"PlanInfo", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/pplan.png"),

		// Arrows
		"right", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/arrowright.png"),
		"top", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/arrowtop.png"),
		"up", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/arrowup.png"),
		"down", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/arrowdown.png"),
		"bottom", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/arrowbottom.png"),
		"delete", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/delete.png"),
		"empty", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/empty.png"),
		"bug_icon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bug_small.png"),

		// Agenda actions.
		"ProcessEventAction", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_message_small.png"),
		"FindApplicableCandidatesAction", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_message_small.png"),
		"SelectCandidatesAction", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_message_small.png"),
		"ScheduleCandidatesAction", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/new_message_small.png"),
		"ExecutePlanStepAction", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/common/images/plan2.png")
	});

	/**
	 *  Get an icon for an element.
	 *  @param classname	The class name of the element (e.g. RBelief).
	 *  @return	The icon for the element.
	 */
	public static Icon	getElementIcon(Object classname)
	{
		return icons.getIcon(classname);
	}

}
