package jadex.adapter.jade.tools.logger.gui;

import jade.core.AID;
import jade.core.ContainerID;
import jade.gui.AgentTree;
import jade.util.leap.ArrayList;
import jade.util.leap.List;
import jade.util.leap.Iterator;
import jadex.adapter.jade.tools.logger.Logger;


/**
 * For log the Agent in the tree.
 * @see jadex.adapter.jade.tools.logger.gui.DoNotLoggerAction
 */

public class DoLoggerAction extends AgentAction
{

    private MainPanel mainPanel;
    private Logger myLogger;
    private AID agentID;
    private AID amsID;
    private ContainerID cid;
    private List loggedAgents = new ArrayList();

    public DoLoggerAction(ActionProcessor actPro, MainPanel mainPanel, Logger myLogger)
    {
        super("DoLoggerActionIcon", "Do log this agent(s)", actPro);
        this.mainPanel = mainPanel;
        this.myLogger = myLogger;
    }

    public void doAction(AgentTree.AgentNode node)
    {
        // set the AID of the selected agent
        agentID = new AID(node.getName(), AID.ISGUID);

        // get the ams of selected agent
        if (node.getParent() instanceof AgentTree.RemotePlatformNode)
        {
            AgentTree.RemotePlatformNode platform = (AgentTree.RemotePlatformNode) node.getParent();
            amsID = platform.getAmsAID();
            // add addresses and resolvers from ams to agent
            Iterator addresses = amsID.getAllAddresses();
            while (addresses.hasNext())
            {
                agentID.addAddresses((String) addresses.next());
            }
            Iterator resolvers = amsID.getAllResolvers();
            while (resolvers.hasNext())
            {
                agentID.addResolvers((AID) resolvers.next());
            }
        }
        else if (node.getParent() instanceof AgentTree.ContainerNode)
        {
            AgentTree.ContainerNode container = (AgentTree.ContainerNode) node.getParent();
            cid = new ContainerID(container.getName(), null);
            amsID = myLogger.getAMS();
        }
        else
        {
            amsID = myLogger.getAMS();
        }

        loggedAgents.add(agentID);
        myLogger.logMsg(loggedAgents, cid, amsID, Logger.LOG_ON);
        loggedAgents.clear();

    }


}
