package jadex.adapter.jade.tools.logger.gui;

import jade.core.AID;
import jade.core.ContainerID;
import jade.gui.AgentTree;
import jade.util.leap.ArrayList;
import jade.util.leap.List;
import jadex.adapter.jade.tools.logger.Logger;

/**
 * For don't log the Agent in the tree.
 * jadex.tools.logger.gui.DoLoggerAction
 */

public class DoNotLoggerAction extends AgentAction
{

    private MainPanel mainPanel;
    private Logger myLogger;
    private AID agentID;
    private AID amsID;
    private ContainerID cid;
    private List loggedAgents = new ArrayList();

    public DoNotLoggerAction(ActionProcessor actPro, MainPanel mainPanel, Logger myLogger)
    {
        super("DoNotLoggerActionIcon", "Do not log this agent(s)", actPro);
        this.mainPanel = mainPanel;
        this.myLogger = myLogger;
    }

    public void doAction(AgentTree.AgentNode node)
    {
        // set the AID of the selected agent and add address if available.
        agentID = new AID(node.getName(), AID.ISGUID);
        if (node.getAddress() != null) agentID.addAddresses(node.getAddress());

        // get the ams of selected agent
        if (node.getParent() instanceof AgentTree.RemotePlatformNode)
        {
            AgentTree.RemotePlatformNode platform = (AgentTree.RemotePlatformNode) node.getParent();
            amsID = platform.getAmsAID();
        }
        else if (node.getParent() instanceof AgentTree.ContainerNode)
        {
            AgentTree.ContainerNode container = (AgentTree.ContainerNode) node.getParent();
            cid = new ContainerID(container.getName(), null);
            amsID = myLogger.getAMS();
        }
        else
        {
            amsID = myLogger.getAMS();
        }

        loggedAgents.add(agentID);
        myLogger.logMsg(loggedAgents,cid, amsID, Logger.LOG_OFF);
        loggedAgents.clear();
    }
}
