package jadex.adapter.jade.tools.logger.gui;

import javax.swing.*;

import jadex.util.SGUI;

/**
 Javadoc documentation for the file
 @author Francisco Regi, Andrea Soracchi - Universita` di Parma
 <Br>
 <a href="mailto:a_soracchi@libero.it"> Andrea Soracchi(e-mail) </a>
 @version $Date: 2005-11-29 08:53:43 +0000 (Tue, 29 Nov 2005) $ $Revision: 3691 $
 */

/**
 * This class loads the icons used in the toolbar and menus
 */
public class GuiProperties
{

	protected static UIDefaults MyDefaults;
	protected static GuiProperties foo = new GuiProperties();
	public static final String ImagePath = "";

	static
	{
		Object[] icons = {
			"LoggerAction.ToggleFilterActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/filter.png"),
			"LoggerAction.RemoveFilterActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/removefilter.png"),
			"LoggerAction.EditFilterActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/editfilter.png"),
			"LoggerAction.AutoscrollActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/autoscroll.png"),
			"LoggerAction.WriteLogFileActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/textfile.png"),
			"LoggerAction.MessageFileActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/textfile.png"),
			"LoggerAction.ShowOnlyActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/bullet4.png"),
			"LoggerAction.AddRemotePlatformActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/connect.png"),
			"LoggerAction.PreloadListActionIcon", SGUI.makeIcon(GuiProperties.class, "/jadex/adapter/jade/tools/logger/gui/images/preload.png"),

			"LoggerAction.ClearTableActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/litter2.png"),
			"LoggerAction.PauseDisplayingActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/pause.png"),
			"LoggerAction.ResizeAllColumnsActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/resize.png"),
			"LoggerAction.DisplayLogFileActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/open.png"),
			"LoggerAction.DoLoggerActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bullet1.png"),
			"LoggerAction.DoNotLoggerActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/bullet2.png"),
			"LoggerAction.ExitActionIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/exit.png"),
			"LoggerAction.RefreshAMSAgentIcon", SGUI.makeIcon(jadex.adapter.jade.tools.common.GuiProperties.class, "/jadex/adapter/jade/tools/common/images/exit.png"),
		};
		MyDefaults = new UIDefaults(icons);
	}

	public static final Icon getIcon(String key)
	{
		Icon icon	= null;
		try
		{
			icon = MyDefaults.getIcon(key);
		}
		catch(RuntimeException e)
		{
			e.printStackTrace();
		}
		if(icon==null)
			System.out.println("Icon not found: "+key);
		return icon;
	}

}  // End of GuiProperties
