/*****************************************************************
JADE - Java Agent DEvelopment Framework is a framework to develop 
multi-agent systems in compliance with the FIPA specifications.
Copyright (C) 2000 CSELT S.p.A. 

GNU Lesser General Public License

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, 
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.
*****************************************************************/

package jadex.adapter.jade.tools.logger.gui;

import jade.gui.AgentTree;
import jadex.adapter.jade.tools.logger.Logger;


/**
   
   @author Tiziana Trucco - CSELT S.p.A.
   @version $Date: 2005-04-26 13:45:51 +0000 (Tue, 26 Apr 2005) $ $Revision: 2556 $
 */
class RefreshAMSAgentAction extends PlatformAction {

  private Logger myLogger;

  public RefreshAMSAgentAction(Logger anLogger, ActionProcessor actPro) {
    super ("RefreshAMSAgentIcon", "Refresh Agent List", actPro);
    myLogger = anLogger;
  }

  public void doAction(AgentTree.Node node ) {

    	if(node instanceof AgentTree.RemotePlatformNode){
	  //System.out.println("Refresh AMS Agent");
    	  myLogger.refreshRemoteAgent(((AgentTree.RemotePlatformNode)node).getAPDescription(),((AgentTree.RemotePlatformNode)node).getAmsAID());
    		
    	}
  }

} 
