package jadex.adapter.jade.tools.logger.ontology;

import jade.content.abs.*;
import jade.content.onto.*;
import jade.content.schema.*;
import java.lang.reflect.*;
import java.io.*;
import java.util.*;


/**
 *  Generated Java class for ontology logger.
 */
public class LoggerOntology	extends jade.content.onto.Ontology
{
	//-------- constants --------

	/** The name of the ontology. */
	public static final String	ONTOLOGY_NAME	= "logger";

	//-------- vocabulary ----------

	public static final String	CHANGEDLOGLEVEL	= "ChangedLogLevel";
	public static final String	CHANGEDLOGLEVEL_AGENT	= "agent";
	public static final String	CHANGEDLOGLEVEL_FROM	= "from";
	public static final String	CHANGEDLOGLEVEL_TO	= "to";
	public static final String	CHANGEDLOGLEVEL_NAME	= "name";

	public static final String	LOGDATA	= "LogData";
	public static final String	LOGDATA_SEQUENCENUMBER	= "sequenceNumber";
	public static final String	LOGDATA_LEVEL	= "level";
	public static final String	LOGDATA_LOGGERNAME	= "loggerName";
	public static final String	LOGDATA_THREADID	= "threadID";
	public static final String	LOGDATA_SOURCECLASSNAME	= "sourceClassName";
	public static final String	LOGDATA_MESSAGE	= "message";
	public static final String	LOGDATA_SOURCEMETHODNAME	= "sourceMethodName";
	public static final String	LOGDATA_MILLIS	= "millis";

	public static final String	LOGMESSAGE	= "LogMessage";
	public static final String	LOGMESSAGE_LOGDATA	= "logData";

	public static final String	LOGOFF	= "LogOff";
	public static final String	LOGOFF_LOGGER	= "logger";
	public static final String	LOGOFF_LOGGEDAGENTS	= "loggedAgents";

	public static final String	LOGON	= "LogOn";
	public static final String	LOGON_LOGGER	= "logger";
	public static final String	LOGON_LOGGEDAGENTS	= "loggedAgents";

	public static final String	LOGREQUEST	= "LogRequest";
	public static final String	LOGREQUEST_STATUS	= "status";
	public static final String	LOGREQUEST_LOGGER	= "logger";
	public static final String	LOGREQUEST_LEVEL	= "level";

	public static final String	PUBLISHEDLOGRECORD	= "PublishedLogRecord";
	public static final String	PUBLISHEDLOGRECORD_LEVEL	= "level";
	public static final String	PUBLISHEDLOGRECORD_LOGGERNAME	= "loggerName";
	public static final String	PUBLISHEDLOGRECORD_MESSAGE	= "message";
	public static final String	PUBLISHEDLOGRECORD_MILLIS	= "millis";
	public static final String	PUBLISHEDLOGRECORD_SEQUENCENUMBER	= "sequenceNumber";
	public static final String	PUBLISHEDLOGRECORD_SOURCECLASSNAME	= "sourceClassName";
	public static final String	PUBLISHEDLOGRECORD_SOURCEMETHODNAME	= "sourceMethodName";
	public static final String	PUBLISHEDLOGRECORD_THREADID	= "threadID";
	public static final String	PUBLISHEDLOGRECORD_NAME	= "name";

	//-------- static part --------

	/** The names of get methods. */
	protected static Map	getternames	= new HashMap();

	/** The names of set methods. */
	protected static Map	setternames	= new HashMap();

	/** The base ontologies. */
	protected static Ontology[]	base;

	static
	{
		List	bases	= new ArrayList();
		bases.add(jade.domain.introspection.IntrospectionOntology.getInstance());
		base	= (Ontology[])bases.toArray(new Ontology[bases.size()]);
	}

	// The singleton instance of this ontology
	private static Ontology	instance	= new LoggerOntology();

	/**
	 *  Get the singleton instance of this ontology.
	 */
	public static Ontology	getInstance()
	{
		return instance;
	}

	//-------- constructors --------

	/**
	 *  Create a new LoggerOntology.
	 */
	private LoggerOntology()
	{
		super(ONTOLOGY_NAME, base, new LoggerOntologyIntrospector());

		try
		{
			// Add ontology classes.
			ConceptSchema oChangedLogLevelSchema	= new ConceptSchema(CHANGEDLOGLEVEL);
			add(oChangedLogLevelSchema, jadex.adapter.jade.tools.logger.ontology.ChangedLogLevel.class);
			ConceptSchema oLogDataSchema	= new ConceptSchema(LOGDATA);
			add(oLogDataSchema, jadex.adapter.jade.tools.logger.ontology.LogData.class);
			AgentActionSchema oLogMessageSchema	= new AgentActionSchema(LOGMESSAGE);
			add(oLogMessageSchema, jadex.adapter.jade.tools.logger.ontology.LogMessage.class);
			AgentActionSchema oLogOffSchema	= new AgentActionSchema(LOGOFF);
			add(oLogOffSchema, jadex.adapter.jade.tools.logger.ontology.LogOff.class);
			AgentActionSchema oLogOnSchema	= new AgentActionSchema(LOGON);
			add(oLogOnSchema, jadex.adapter.jade.tools.logger.ontology.LogOn.class);
			AgentActionSchema oLogRequestSchema	= new AgentActionSchema(LOGREQUEST);
			add(oLogRequestSchema, jadex.adapter.jade.tools.logger.ontology.LogRequest.class);
			ConceptSchema oPublishedLogRecordSchema	= new ConceptSchema(PUBLISHEDLOGRECORD);
			add(oPublishedLogRecordSchema, jadex.adapter.jade.tools.logger.ontology.PublishedLogRecord.class);

			// Add slots to classes.
			oChangedLogLevelSchema.add(CHANGEDLOGLEVEL_AGENT, (ConceptSchema)getSchema("agent-identifier"), ObjectSchema.OPTIONAL);
			oChangedLogLevelSchema.add(CHANGEDLOGLEVEL_FROM, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oChangedLogLevelSchema.add(CHANGEDLOGLEVEL_TO, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oChangedLogLevelSchema.add(CHANGEDLOGLEVEL_NAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);

			oLogDataSchema.add(LOGDATA_SEQUENCENUMBER, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_LEVEL, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_LOGGERNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_THREADID, (PrimitiveSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_SOURCECLASSNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_MESSAGE, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_SOURCEMETHODNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oLogDataSchema.add(LOGDATA_MILLIS, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);

			oLogMessageSchema.add(LOGMESSAGE_LOGDATA, (ConceptSchema)getSchema("LogData"), ObjectSchema.MANDATORY);

			oLogOffSchema.add(LOGOFF_LOGGER, (ConceptSchema)getSchema("agent-identifier"), ObjectSchema.MANDATORY);
			oLogOffSchema.add(LOGOFF_LOGGEDAGENTS, (ConceptSchema)getSchema("agent-identifier"), 1, -1);

			oLogOnSchema.add(LOGON_LOGGER, (ConceptSchema)getSchema("agent-identifier"), ObjectSchema.MANDATORY);
			oLogOnSchema.add(LOGON_LOGGEDAGENTS, (ConceptSchema)getSchema("agent-identifier"), 1, -1);

			oLogRequestSchema.add(LOGREQUEST_STATUS, (PrimitiveSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.MANDATORY);
			oLogRequestSchema.add(LOGREQUEST_LOGGER, (ConceptSchema)getSchema("agent-identifier"), ObjectSchema.MANDATORY);
			oLogRequestSchema.add(LOGREQUEST_LEVEL, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);

			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_LEVEL, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_LOGGERNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_MESSAGE, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_MILLIS, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_SEQUENCENUMBER, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_SOURCECLASSNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_SOURCEMETHODNAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_THREADID, (PrimitiveSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
			oPublishedLogRecordSchema.add(PUBLISHEDLOGRECORD_NAME, (PrimitiveSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);

			// Add inheritance relations.

			// Store names for getter/setter methods.
			// Todo: only store modified names...
			Map	oChangedLogLevelGetter	= new HashMap();
			Map	oChangedLogLevelSetter	= new HashMap();
			getternames.put(oChangedLogLevelSchema, oChangedLogLevelGetter);
			setternames.put(oChangedLogLevelSchema, oChangedLogLevelSetter);
			oChangedLogLevelGetter.put("agent", "getAgent");
			oChangedLogLevelSetter.put("agent", "setAgent");
			oChangedLogLevelGetter.put("from", "getFrom");
			oChangedLogLevelSetter.put("from", "setFrom");
			oChangedLogLevelGetter.put("name", "getName");
			oChangedLogLevelSetter.put("name", "setName");
			oChangedLogLevelGetter.put("to", "getTo");
			oChangedLogLevelSetter.put("to", "setTo");

			Map	oLogDataGetter	= new HashMap();
			Map	oLogDataSetter	= new HashMap();
			getternames.put(oLogDataSchema, oLogDataGetter);
			setternames.put(oLogDataSchema, oLogDataSetter);
			oLogDataGetter.put("level", "getLevel");
			oLogDataSetter.put("level", "setLevel");
			oLogDataGetter.put("loggerName", "getLoggerName");
			oLogDataSetter.put("loggerName", "setLoggerName");
			oLogDataGetter.put("message", "getMessage");
			oLogDataSetter.put("message", "setMessage");
			oLogDataGetter.put("millis", "getMillis");
			oLogDataSetter.put("millis", "setMillis");
			oLogDataGetter.put("sequenceNumber", "getSequenceNumber");
			oLogDataSetter.put("sequenceNumber", "setSequenceNumber");
			oLogDataGetter.put("sourceClassName", "getSourceClassName");
			oLogDataSetter.put("sourceClassName", "setSourceClassName");
			oLogDataGetter.put("sourceMethodName", "getSourceMethodName");
			oLogDataSetter.put("sourceMethodName", "setSourceMethodName");
			oLogDataGetter.put("threadID", "getThreadID");
			oLogDataSetter.put("threadID", "setThreadID");

			Map	oLogMessageGetter	= new HashMap();
			Map	oLogMessageSetter	= new HashMap();
			getternames.put(oLogMessageSchema, oLogMessageGetter);
			setternames.put(oLogMessageSchema, oLogMessageSetter);
			oLogMessageGetter.put("logData", "getLogData");
			oLogMessageSetter.put("logData", "setLogData");

			Map	oLogOffGetter	= new HashMap();
			Map	oLogOffSetter	= new HashMap();
			getternames.put(oLogOffSchema, oLogOffGetter);
			setternames.put(oLogOffSchema, oLogOffSetter);
			oLogOffGetter.put("loggedAgents", "getLoggedAgents");
			oLogOffSetter.put("loggedAgents", "setLoggedAgents");
			oLogOffGetter.put("logger", "getLogger");
			oLogOffSetter.put("logger", "setLogger");

			Map	oLogOnGetter	= new HashMap();
			Map	oLogOnSetter	= new HashMap();
			getternames.put(oLogOnSchema, oLogOnGetter);
			setternames.put(oLogOnSchema, oLogOnSetter);
			oLogOnGetter.put("loggedAgents", "getLoggedAgents");
			oLogOnSetter.put("loggedAgents", "setLoggedAgents");
			oLogOnGetter.put("logger", "getLogger");
			oLogOnSetter.put("logger", "setLogger");

			Map	oLogRequestGetter	= new HashMap();
			Map	oLogRequestSetter	= new HashMap();
			getternames.put(oLogRequestSchema, oLogRequestGetter);
			setternames.put(oLogRequestSchema, oLogRequestSetter);
			oLogRequestGetter.put("level", "getLevel");
			oLogRequestSetter.put("level", "setLevel");
			oLogRequestGetter.put("logger", "getLogger");
			oLogRequestSetter.put("logger", "setLogger");
			oLogRequestGetter.put("status", "isStatus");
			oLogRequestSetter.put("status", "setStatus");

			Map	oPublishedLogRecordGetter	= new HashMap();
			Map	oPublishedLogRecordSetter	= new HashMap();
			getternames.put(oPublishedLogRecordSchema, oPublishedLogRecordGetter);
			setternames.put(oPublishedLogRecordSchema, oPublishedLogRecordSetter);
			oPublishedLogRecordGetter.put("level", "getLevel");
			oPublishedLogRecordSetter.put("level", "setLevel");
			oPublishedLogRecordGetter.put("loggerName", "getLoggerName");
			oPublishedLogRecordSetter.put("loggerName", "setLoggerName");
			oPublishedLogRecordGetter.put("message", "getMessage");
			oPublishedLogRecordSetter.put("message", "setMessage");
			oPublishedLogRecordGetter.put("millis", "getMillis");
			oPublishedLogRecordSetter.put("millis", "setMillis");
			oPublishedLogRecordGetter.put("name", "getName");
			oPublishedLogRecordSetter.put("name", "setName");
			oPublishedLogRecordGetter.put("sequenceNumber", "getSequenceNumber");
			oPublishedLogRecordSetter.put("sequenceNumber", "setSequenceNumber");
			oPublishedLogRecordGetter.put("sourceClassName", "getSourceClassName");
			oPublishedLogRecordSetter.put("sourceClassName", "setSourceClassName");
			oPublishedLogRecordGetter.put("sourceMethodName", "getSourceMethodName");
			oPublishedLogRecordSetter.put("sourceMethodName", "setSourceMethodName");
			oPublishedLogRecordGetter.put("threadID", "getThreadID");
			oPublishedLogRecordSetter.put("threadID", "setThreadID");

		}
		catch(OntologyException e)
		{
			// Shouldn't happen?
			throw new RuntimeException(e.toString());
		}
	}
}

//-------- helper classes --------

/**
 *  Introspector to convert java objects to and from abstract descriptors.
 */
class LoggerOntologyIntrospector	implements Introspector
{
	//-------- attributes --------

	/** Getter method cache (schema->(slot->method)). */
	protected static Map gettercache	= Collections.synchronizedMap(new HashMap());

	/** Setter method cache (schema->(slot->method)). */
	protected static Map settercache	= Collections.synchronizedMap(new HashMap());

	//-------- Introspector interface --------

	/**
	 *  Convert a java object into an abstract descriptor.
	 */
	public AbsObject	externalise(Object obj, ObjectSchema schema,
		Class clazz, Ontology onto)
		throws OntologyException
	{
		try
		{
			// Create abstract descriptor.
			AbsObject    ret = schema.newInstance();            

			// Iterate over slots.
			String[]     slots = schema.getNames();
			for(int i=0; i<slots.length; i++)
			{
				// Try to invoke getter method.
				Method	getter	= getGetterMethod(schema, slots[i], onto);
				Object	value	= getter.invoke(obj, new Object[0]);

				// Set value of slot.
				if(value!=null)
				{
					// Fill in values of multi slot.
					if(schema.getSchema(slots[i]) instanceof AggregateSchema)
					{
						AbsAggregate	absvalue	= new AbsAggregate(schema.getSchema(slots[i]).getTypeName());
						for(Iterator it=getIterator(value); it.hasNext(); )
						{
							absvalue.add((AbsTerm)onto.fromObject(it.next()));
						}
						AbsHelper.setAttribute(ret, slots[i], absvalue);
					}

					// Set scalar slot.
					else
					{
						AbsObject	absvalue	= onto.fromObject(value);
						AbsHelper.setAttribute(ret, slots[i], absvalue);
					}
				}
			}

			return ret;
		}
		catch(InvocationTargetException e)
		{
			if(e.getTargetException() instanceof RuntimeException)
			{
				throw (RuntimeException)e.getTargetException();
			}
			else
			{
				StringWriter	sw = new StringWriter();
				e.getTargetException().printStackTrace(new PrintWriter(sw));
				throw new RuntimeException(""+sw);
			}
		} 
		catch(IllegalAccessException e)
		{
			StringWriter	sw = new StringWriter();
			e.printStackTrace(new PrintWriter(sw));
			throw new RuntimeException(""+sw);
		} 
	}

	/**
	 *  Convert an abstract descriptor into a java object.
	 */
	public Object	internalise(AbsObject abs, ObjectSchema schema,
		Class clazz, Ontology onto) 
		throws UngroundedException, OntologyException
	{
		try
		{
			// Create Java object.
			Object	ret	= clazz.newInstance();

			// Iterate over slots.
			String[]     slots = schema.getNames();
			for(int i=0; i<slots.length; i++)
			{
				// Get slot value.
				AbsObject	absvalue	= abs.getAbsObject(slots[i]);
				if(absvalue!=null)
				{
					Object	value	= onto.toObject(absvalue);

					// Try to invoke setter method.
					Method	setter	= getSetterMethod(schema, slots[i], onto);
					Class	param	= setter.getParameterTypes()[0];

					// Convert list to array. Hack???
					if(value instanceof jade.util.leap.List && param.isArray())
					{
						jade.util.leap.Iterator	it	= ((jade.util.leap.List)value).iterator();
						value	= Array.newInstance(param.getComponentType(),
							((jade.util.leap.List)value).size());
						for(int j=0; it.hasNext(); j++)
						{
							Array.set(value, j, it.next());
						}
					}

					// Convert Long to Integer. Hack???
					else if(value instanceof Long && (param==Integer.class || param==int.class))
					{
						value	= new Integer(((Number)value).intValue());
					}

					// Convert Double to Float. Hack???
					else if(value instanceof Double && (param==Float.class || param==float.class))
					{
						value	= new Float(((Number)value).floatValue());
					}

					setter.invoke(ret, new Object[]{value});
				}
			}

			return ret;
		}
		catch(InvocationTargetException e)
		{
			if(e.getTargetException() instanceof RuntimeException)
			{
				throw (RuntimeException)e.getTargetException();
			}
			else
			{
				StringWriter	sw = new StringWriter();
				e.getTargetException().printStackTrace(new PrintWriter(sw));
				throw new RuntimeException(""+sw);
			}
		} 
		catch(IllegalAccessException e)
		{
			StringWriter	sw = new StringWriter();
			e.printStackTrace(new PrintWriter(sw));
			throw new RuntimeException(""+sw);
		} 
		catch(InstantiationException e)
		{
			StringWriter	sw = new StringWriter();
			e.printStackTrace(new PrintWriter(sw));
			throw new RuntimeException(""+sw);
		} 
	}
					
	/**
	 *  Check match between given object schema and Java class.
	 */
	public void	checkClass(ObjectSchema schema, Class clazz, Ontology onto)
		throws OntologyException
	{
		// Todo: Implement checks.
	}

	//-------- helper methods --------

	/**
	 *  Find the getter method for a slot.
	 */
	protected Method	getGetterMethod(ObjectSchema schema, String slot,
		Ontology onto)	throws OntologyException
	{
		// Try to find method in cache.
		Map	getters	= (Map)gettercache.get(schema);
		if(getters==null)
		{
			getters	= new HashMap();
			gettercache.put(schema, getters);
		}
		Method	getter	= (Method)getters.get(slot);

		if(getter==null)
		{
			String	gettername	= (String)((Map)LoggerOntology.getternames.get(schema)).get(slot);
			Class	clazz	= onto.getClassForElement(schema.getTypeName());
			getter	= getMethod(clazz, gettername, 0);
			if(getter==null)
			{
				throw new OntologyException("Getter method "+gettername
					+" for slot "+slot+" of class "+clazz+" not found.");
			}
			getters.put(slot, getter);
		}

		return getter;
	}

	/**
	 *  Find the setter method for a slot.
	 */
	protected Method	getSetterMethod(ObjectSchema schema, String slot,
		Ontology onto)	throws OntologyException
	{
		// Try to find method in cache.
		Map	setters	= (Map)settercache.get(schema);
		if(setters==null)
		{
			setters	= new HashMap();
			settercache.put(schema, setters);
		}
		Method	setter	= (Method)setters.get(slot);

		if(setter==null)
		{
			String	settername	= (String)((Map)LoggerOntology.setternames.get(schema)).get(slot);
			Class	clazz	= onto.getClassForElement(schema.getTypeName());
			setter	= getMethod(clazz, settername, 1);
			if(setter==null)
			{
				throw new OntologyException("Setter method "+settername
					+" of class "+clazz+" not found.");
			}
			setters.put(slot, setter);
		}

		return setter;
	}

	/**
	 *  Get a public method of a class by name.
	 *  @param clazz	The class to search.
	 *  @param name	The name of the method to search for.
	 *  @param args	The required number of arguments.
	 *  @return	The method, or null if not found.
	 */
	protected Method	getMethod(Class clazz, String name, int args)
	{
		Method[]	ms	= clazz.getMethods();
		for(int i=0; i<ms.length; i++)
		{
			if(ms[i].getName().equals(name)
				&& ms[i].getParameterTypes().length==args)
			{
				return ms[i];
			}
		}
		return null;
	}

	/**
	 *  Get an iterator for an arbitrary collection object.
	 *  Supports iterators, enumerations, java.util.Collections,
	 *  java.util.Maps, arrays.
	 *  @param collection	The collection object.
	 *  @return An iterator over the collection.
	 */
	protected static Iterator	getIterator(Object collection)
	{
		if(collection instanceof Iterator)
		{
			return (Iterator)collection;
		}
		else if(collection instanceof Enumeration)
		{
			// Return enumeration wrapper.
			final Enumeration eoc	= (Enumeration)collection;
			return new Iterator()
			{
				public boolean	hasNext()	{return eoc.hasMoreElements();}
				public Object	next()	{return eoc.nextElement();}
				public void	remove(){throw new UnsupportedOperationException(
					"remove() not supported for enumerations");}
			};
		}
		else if(collection instanceof Collection)
		{
			return ((Collection)collection).iterator();
		}
		else if(collection instanceof Map)
		{
			return ((Map)collection).values().iterator();
		}
		else if(collection!=null && collection.getClass().isArray())
		{
			// Return array wrapper.
			final Object array	= collection;
			return new Iterator()
			{
				int i=0;
				public boolean	hasNext()	{return i<Array.getLength(array);}
				public Object	next()	{return Array.get(array, i++);}
				public void	remove()	{throw new UnsupportedOperationException(
					"remove() not supported for arrays");}
			};
		}
		else
		{
			throw new RuntimeException("Cannot iterate over "+collection);
		}
	}
}

